/// <reference types="node" />
import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
import * as definedTypes from '../../types';
export declare type MarketAccountDataArgs = {
    store: web3.PublicKey;
    sellingResource: web3.PublicKey;
    treasuryMint: web3.PublicKey;
    treasuryHolder: web3.PublicKey;
    treasuryOwner: web3.PublicKey;
    owner: web3.PublicKey;
    name: string;
    description: string;
    mutable: boolean;
    price: beet.bignum;
    piecesInOneWallet: beet.COption<beet.bignum>;
    startDate: beet.bignum;
    endDate: beet.COption<beet.bignum>;
    state: definedTypes.MarketState;
    fundsCollected: beet.bignum;
};
export declare class MarketAccountData implements MarketAccountDataArgs {
    readonly store: web3.PublicKey;
    readonly sellingResource: web3.PublicKey;
    readonly treasuryMint: web3.PublicKey;
    readonly treasuryHolder: web3.PublicKey;
    readonly treasuryOwner: web3.PublicKey;
    readonly owner: web3.PublicKey;
    readonly name: string;
    readonly description: string;
    readonly mutable: boolean;
    readonly price: beet.bignum;
    readonly piecesInOneWallet: beet.COption<beet.bignum>;
    readonly startDate: beet.bignum;
    readonly endDate: beet.COption<beet.bignum>;
    readonly state: definedTypes.MarketState;
    readonly fundsCollected: beet.bignum;
    private constructor();
    static fromArgs(args: MarketAccountDataArgs): MarketAccountData;
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [MarketAccountData, number];
    static deserialize(buf: Buffer, offset?: number): [MarketAccountData, number];
    static byteSize(args: MarketAccountDataArgs): number;
    static getMinimumBalanceForRentExemption(args: MarketAccountDataArgs, connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    serialize(): [Buffer, number];
    pretty(): {
        store: string;
        sellingResource: string;
        treasuryMint: string;
        treasuryHolder: string;
        treasuryOwner: string;
        owner: string;
        name: string;
        description: string;
        mutable: boolean;
        price: beet.bignum;
        piecesInOneWallet: beet.COption<beet.bignum>;
        startDate: beet.bignum;
        endDate: beet.COption<beet.bignum>;
        state: definedTypes.MarketState;
        fundsCollected: beet.bignum;
    };
}
