/// <reference types="node" />
import * as web3 from '@solana/web3.js';
import * as definedTypes from '../../types';
export declare type PrimaryMetadataCreatorsAccountDataArgs = {
    creators: definedTypes.Creator[];
};
export declare class PrimaryMetadataCreatorsAccountData implements PrimaryMetadataCreatorsAccountDataArgs {
    readonly creators: definedTypes.Creator[];
    private constructor();
    static fromArgs(args: PrimaryMetadataCreatorsAccountDataArgs): PrimaryMetadataCreatorsAccountData;
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [PrimaryMetadataCreatorsAccountData, number];
    static deserialize(buf: Buffer, offset?: number): [PrimaryMetadataCreatorsAccountData, number];
    static byteSize(args: PrimaryMetadataCreatorsAccountDataArgs): number;
    static getMinimumBalanceForRentExemption(args: PrimaryMetadataCreatorsAccountDataArgs, connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    serialize(): [Buffer, number];
    pretty(): {
        creators: definedTypes.Creator[];
    };
}
