/// <reference types="node" />
import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
import * as definedTypes from '../../types';
export declare type SellingResourceAccountDataArgs = {
    store: web3.PublicKey;
    owner: web3.PublicKey;
    resource: web3.PublicKey;
    vault: web3.PublicKey;
    vaultOwner: web3.PublicKey;
    supply: beet.bignum;
    maxSupply: beet.COption<beet.bignum>;
    state: definedTypes.SellingResourceState;
};
export declare class SellingResourceAccountData implements SellingResourceAccountDataArgs {
    readonly store: web3.PublicKey;
    readonly owner: web3.PublicKey;
    readonly resource: web3.PublicKey;
    readonly vault: web3.PublicKey;
    readonly vaultOwner: web3.PublicKey;
    readonly supply: beet.bignum;
    readonly maxSupply: beet.COption<beet.bignum>;
    readonly state: definedTypes.SellingResourceState;
    private constructor();
    static fromArgs(args: SellingResourceAccountDataArgs): SellingResourceAccountData;
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [SellingResourceAccountData, number];
    static deserialize(buf: Buffer, offset?: number): [SellingResourceAccountData, number];
    static byteSize(args: SellingResourceAccountDataArgs): number;
    static getMinimumBalanceForRentExemption(args: SellingResourceAccountDataArgs, connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    serialize(): [Buffer, number];
    pretty(): {
        store: string;
        owner: string;
        resource: string;
        vault: string;
        vaultOwner: string;
        supply: beet.bignum;
        maxSupply: beet.COption<beet.bignum>;
        state: definedTypes.SellingResourceState;
    };
}
