"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoreAccountData = void 0;
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
const beet = __importStar(require("@metaplex-foundation/beet"));
const storeAccountDiscriminator = [130, 48, 247, 244, 182, 191, 30, 26];
class StoreAccountData {
    constructor(admin, name, description) {
        this.admin = admin;
        this.name = name;
        this.description = description;
    }
    static fromArgs(args) {
        return new StoreAccountData(args.admin, args.name, args.description);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return StoreAccountData.deserialize(accountInfo.data, offset);
    }
    static deserialize(buf, offset = 0) {
        return storeAccountDataStruct.deserialize(buf, offset);
    }
    static byteSize(args) {
        const instance = StoreAccountData.fromArgs(args);
        return storeAccountDataStruct.toFixedFromValue({
            accountDiscriminator: storeAccountDiscriminator,
            ...instance,
        }).byteSize;
    }
    static async getMinimumBalanceForRentExemption(args, connection, commitment) {
        return connection.getMinimumBalanceForRentExemption(StoreAccountData.byteSize(args), commitment);
    }
    serialize() {
        return storeAccountDataStruct.serialize({
            accountDiscriminator: storeAccountDiscriminator,
            ...this,
        });
    }
    pretty() {
        return {
            admin: this.admin.toBase58(),
            name: this.name,
            description: this.description,
        };
    }
}
exports.StoreAccountData = StoreAccountData;
const storeAccountDataStruct = new beet.FixableBeetStruct([
    ['accountDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['admin', beetSolana.publicKey],
    ['name', beet.utf8String],
    ['description', beet.utf8String],
], StoreAccountData.fromArgs, 'StoreAccountData');
//# sourceMappingURL=Store.js.map