/// <reference types="node" />
import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
export declare type TradeHistoryAccountDataArgs = {
    market: web3.PublicKey;
    wallet: web3.PublicKey;
    alreadyBought: beet.bignum;
};
export declare class TradeHistoryAccountData implements TradeHistoryAccountDataArgs {
    readonly market: web3.PublicKey;
    readonly wallet: web3.PublicKey;
    readonly alreadyBought: beet.bignum;
    private constructor();
    static get byteSize(): number;
    static fromArgs(args: TradeHistoryAccountDataArgs): TradeHistoryAccountData;
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [TradeHistoryAccountData, number];
    static deserialize(buf: Buffer, offset?: number): [TradeHistoryAccountData, number];
    static getMinimumBalanceForRentExemption(connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    static hasCorrectByteSize(buf: Buffer, offset?: number): boolean;
    serialize(): [Buffer, number];
    pretty(): {
        market: string;
        wallet: string;
        alreadyBought: beet.bignum;
    };
}
