"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TradeHistoryAccountData = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
const tradeHistoryAccountDiscriminator = [190, 117, 218, 114, 66, 112, 56, 41];
class TradeHistoryAccountData {
    constructor(market, wallet, alreadyBought) {
        this.market = market;
        this.wallet = wallet;
        this.alreadyBought = alreadyBought;
    }
    static get byteSize() {
        return tradeHistoryAccountDataStruct.byteSize;
    }
    static fromArgs(args) {
        return new TradeHistoryAccountData(args.market, args.wallet, args.alreadyBought);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return TradeHistoryAccountData.deserialize(accountInfo.data, offset);
    }
    static deserialize(buf, offset = 0) {
        return tradeHistoryAccountDataStruct.deserialize(buf, offset);
    }
    static async getMinimumBalanceForRentExemption(connection, commitment) {
        return connection.getMinimumBalanceForRentExemption(TradeHistoryAccountData.byteSize, commitment);
    }
    static hasCorrectByteSize(buf, offset = 0) {
        return buf.byteLength - offset === TradeHistoryAccountData.byteSize;
    }
    serialize() {
        return tradeHistoryAccountDataStruct.serialize({
            accountDiscriminator: tradeHistoryAccountDiscriminator,
            ...this,
        });
    }
    pretty() {
        return {
            market: this.market.toBase58(),
            wallet: this.wallet.toBase58(),
            alreadyBought: this.alreadyBought,
        };
    }
}
exports.TradeHistoryAccountData = TradeHistoryAccountData;
const tradeHistoryAccountDataStruct = new beet.BeetStruct([
    ['accountDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['market', beetSolana.publicKey],
    ['wallet', beetSolana.publicKey],
    ['alreadyBought', beet.u64],
], TradeHistoryAccountData.fromArgs, 'TradeHistoryAccountData');
//# sourceMappingURL=TradeHistory.js.map