import * as web3 from '@solana/web3.js';
export declare type BuyInstructionArgs = {
    tradeHistoryBump: number;
    vaultOwnerBump: number;
};
export declare type BuyInstructionAccounts = {
    market: web3.PublicKey;
    sellingResource: web3.PublicKey;
    userTokenAccount: web3.PublicKey;
    userWallet: web3.PublicKey;
    tradeHistory: web3.PublicKey;
    treasuryHolder: web3.PublicKey;
    newMetadata: web3.PublicKey;
    newEdition: web3.PublicKey;
    masterEdition: web3.PublicKey;
    newMint: web3.PublicKey;
    editionMarker: web3.PublicKey;
    vault: web3.PublicKey;
    owner: web3.PublicKey;
    newTokenAccount: web3.PublicKey;
    masterEditionMetadata: web3.PublicKey;
    tokenMetadataProgram: web3.PublicKey;
};
export declare function createBuyInstruction(accounts: BuyInstructionAccounts, args: BuyInstructionArgs): web3.TransactionInstruction;
