"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createBuyInstruction = void 0;
const splToken = __importStar(require("@solana/spl-token"));
const beet = __importStar(require("@metaplex-foundation/beet"));
const web3 = __importStar(require("@solana/web3.js"));
const consts_1 = require("../../consts");
const buyStruct = new beet.BeetArgsStruct([
    ['instructionDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['tradeHistoryBump', beet.u8],
    ['vaultOwnerBump', beet.u8],
], 'BuyInstructionArgs');
const buyInstructionDiscriminator = [102, 6, 61, 18, 1, 218, 235, 234];
function createBuyInstruction(accounts, args) {
    const { market, sellingResource, userTokenAccount, userWallet, tradeHistory, treasuryHolder, newMetadata, newEdition, masterEdition, newMint, editionMarker, vault, owner, newTokenAccount, masterEditionMetadata, tokenMetadataProgram, } = accounts;
    const [data] = buyStruct.serialize({
        instructionDiscriminator: buyInstructionDiscriminator,
        ...args,
    });
    const keys = [
        {
            pubkey: market,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: sellingResource,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: userTokenAccount,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: userWallet,
            isWritable: true,
            isSigner: true,
        },
        {
            pubkey: tradeHistory,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: treasuryHolder,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: newMetadata,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: newEdition,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: masterEdition,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: newMint,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: editionMarker,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: vault,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: owner,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: newTokenAccount,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: masterEditionMetadata,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: web3.SYSVAR_CLOCK_PUBKEY,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: web3.SYSVAR_RENT_PUBKEY,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: tokenMetadataProgram,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: splToken.TOKEN_PROGRAM_ID,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: web3.SystemProgram.programId,
            isWritable: false,
            isSigner: false,
        },
    ];
    const ix = new web3.TransactionInstruction({
        programId: new web3.PublicKey(consts_1.PROGRAM_ID),
        keys,
        data,
    });
    return ix;
}
exports.createBuyInstruction = createBuyInstruction;
//# sourceMappingURL=buy.js.map