import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
export declare type CreateMarketInstructionArgs = {
    treasuryOwnerBump: number;
    name: string;
    description: string;
    mutable: boolean;
    price: beet.bignum;
    piecesInOneWallet: beet.COption<beet.bignum>;
    startDate: beet.bignum;
    endDate: beet.COption<beet.bignum>;
};
export declare type CreateMarketInstructionAccounts = {
    market: web3.PublicKey;
    store: web3.PublicKey;
    sellingResourceOwner: web3.PublicKey;
    sellingResource: web3.PublicKey;
    mint: web3.PublicKey;
    treasuryHolder: web3.PublicKey;
    owner: web3.PublicKey;
};
export declare function createCreateMarketInstruction(accounts: CreateMarketInstructionAccounts, args: CreateMarketInstructionArgs): web3.TransactionInstruction;
