"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createCreateStoreInstruction = void 0;
const web3 = __importStar(require("@solana/web3.js"));
const beet = __importStar(require("@metaplex-foundation/beet"));
const consts_1 = require("../../consts");
const createStoreStruct = new beet.FixableBeetArgsStruct([
    ['instructionDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['name', beet.utf8String],
    ['description', beet.utf8String],
], 'CreateStoreInstructionArgs');
const createStoreInstructionDiscriminator = [132, 152, 9, 27, 112, 19, 95, 83];
function createCreateStoreInstruction(accounts, args) {
    const { admin, store } = accounts;
    const [data] = createStoreStruct.serialize({
        instructionDiscriminator: createStoreInstructionDiscriminator,
        ...args,
    });
    const keys = [
        {
            pubkey: admin,
            isWritable: true,
            isSigner: true,
        },
        {
            pubkey: store,
            isWritable: true,
            isSigner: true,
        },
        {
            pubkey: web3.SystemProgram.programId,
            isWritable: false,
            isSigner: false,
        },
    ];
    const ix = new web3.TransactionInstruction({
        programId: new web3.PublicKey(consts_1.PROGRAM_ID),
        keys,
        data,
    });
    return ix;
}
exports.createCreateStoreInstruction = createCreateStoreInstruction;
//# sourceMappingURL=createStore.js.map