"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMetadata = void 0;
const amman_1 = require("@metaplex-foundation/amman");
const mpl_token_metadata_1 = require("@metaplex-foundation/mpl-token-metadata");
async function createMetadata({ transactionHandler, publicKey, editionMint, metadataData, }) {
    const metadata = await mpl_token_metadata_1.Metadata.getPDA(editionMint);
    const createMetadataTx = new mpl_token_metadata_1.CreateMetadata({ feePayer: publicKey }, {
        metadata,
        metadataData,
        updateAuthority: publicKey,
        mint: editionMint,
        mintAuthority: publicKey,
    });
    const createTxDetails = await transactionHandler.sendAndConfirmTransaction(createMetadataTx, [], amman_1.defaultSendOptions);
    return { metadata, createTxDetails };
}
exports.createMetadata = createMetadata;
//# sourceMappingURL=createMetadata.js.map