"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAndSignTransaction = void 0;
const web3_js_1 = require("@solana/web3.js");
async function createAndSignTransaction(connection, payer, instructions, signers) {
    const tx = new web3_js_1.Transaction();
    tx.add(...instructions);
    tx.recentBlockhash = (await connection.getRecentBlockhash()).blockhash;
    tx.feePayer = payer.publicKey;
    tx.partialSign(...signers);
    return tx;
}
exports.createAndSignTransaction = createAndSignTransaction;
//# sourceMappingURL=createAndSignTransaction.js.map